#!/usr/bin/python
import shelve,sys, os, shutil, time

if len(sys.argv) < 5 or len(sys.argv) > 6:
	print "whanker.  need at least 4 args, death-db being first, death watch interval being second,"
	print "hours from midnight that mirror-dist runs at, and finally directory for lists being second"
	print "third, urldb, is optional"
	sys.exit(1)

interval=int(sys.argv[2])
run_hour=int(sys.argv[3])
targdir=sys.argv[4]

url_db = {}
if len(sys.argv) >= 6:
	url_db = shelve.open(sys.argv[5], "r")

db=shelve.open(sys.argv[1],"r")
targets={}
for file, timestamp in db.items():
	if not timestamp in targets:	targets[timestamp] = []
	targets[timestamp].append(file)

l=targets.keys()
l.sort()
#sorted timestamps.
#now collapse them.
l2={}
for x in l:
	files = targets[x]
	x = float(x) + float(interval)
	ctup=time.gmtime(x)
	if ctup.tm_hour >= run_hour:
		#offset the time to the next day.
		x += (24 - run_hour) * 60 * 60
		ctup=time.gmtime(float(x))
	fn=time.strftime("%Y-%m-%d.list", ctup)
	if fn in l2:
		l2[fn].extend(files)
	else:
		l2[fn] = files[:]

for filename, files in l2.items():
	files.sort()
	try:
		f=open(os.path.join(targdir, filename), "w")
		for x in files:
			f.write("%s\t%s\n" % (x, url_db.get(x,"unknown")))
		f.close()
	except (OSError, IOError), e:
		print "caught an exception trying to write for timestamp %s" % str(timestamp), e

db.close()
try:			url_db.close()
except AttributeError:	pass
